<template>
  <div id="app">
<!--
    - render function
    - refs
    - mixins
    - custom directive
    - animation
    - filters
    - динамичные компоненты( теги: keep-alive & component + v-bind:is )
-->

<!--------------------------------------MIXINS----------------------------------------------->

    <div class="tabs">
      <button
          v-for="(title, key) in tabs"
          :key="`tab_${key}`"
          :style="{'background-color': curTab === key ? 'green' : 'transparent', 'color': curTab === key ? '#fff' : '#000'}"
          @click="curTab = key"
          type="button"
      >{{ title }}</button>
    </div>
    <div class="tabs-content">
        <transition name="tabs" mode="out-in">
            <component :is="curTab"></component>
        </transition>


    </div>
  </div>

    <!--  c/h work

        Создать миксин для кнопок:
        - props: type, label
        - метод с именем handler:
          - принимает два параметра $event и callback
          - добавить любой код, который будет общим для всех кнопок или вывести в консоль строку
          - callback вызывать до $emit и передавать в него $event

        -----------------------------------------------------

        СОздать директивы:

        1 afterLoop
           - должна вызывать переданный колбек в конце цикла
        ------
        2 classBuilder
           - создать несколько класов с одинаковым префиксом
           - директива дожна принимать модификатор класса
           - добавлять элементу соответствущий класс


        -----------------------------------------------------

        Создать фильтр
        - принемает число и массив слов
        - выводит склоненное слово в зависимости от числа

        -----------------------------------------------------

        Создать слайдер

        -----------------------------------------------------
        To-do-list
            - добавить анимацию для поп-ап и вывода списков
            - добавить менять вывод задач. 3 в ряд и 1 в ряд
            - сделать валидацию картинки по расширению, принимать только .png .jpg
            - добавить панель "лента" для всех юзеров
                - выводить "Пользователь <имя> добавил\а задачу <тайтл задачи> + время + статус задачи"
                - при помощи фильтра менять слово "добавил\а"

    -->

</template>

<script>
import Mixins from './components/Mixins'
import Directives from './components/Directives'
import Filters from './components/Filters'

//import Slider from './components/slider/Slider'

export default {
  name: 'app',

  components: {
    Mixins, Directives, Filters
  },
  data() {
    return {
      curTab: 'mixins',
      tabs: {
          mixins: 'Mixins + Refs + Render fn.',
          directives: 'Directives + Animation',
          filters: 'Filters'
       }
    }

  }
}
</script>

<style lang="sass">
    @import "~bootstrap/scss/bootstrap"
    #app
      font-family: 'Avenir', Helvetica, Arial, sans-serif
      -webkit-font-smoothing: antialiased
      -moz-osx-font-smoothing: grayscale
      text-align: center
      color: #2c3e50
      margin-top: 60px

    .tabs-enter-active, .tabs-leave-active
        transition: .3s ease

    .tabs-enter, .tabs-leave-to
      opacity: 0

    .tabs-leave-to
      transform: translateX(30%)

    .tabs-enter
      transform: translateX(-30%)


</style>
